Index: external/fastjet/contribs/Nsubjettiness/NEWS
===================================================================
--- external/fastjet/contribs/Nsubjettiness/NEWS	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/NEWS	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -10,5 +10,5 @@
 Note that we have maintain backwards compatibility for the typical ways that
 Nsubjettiness was used.  In particular, all of the Nsubjettiness class code in
-the example file v1.0.3 from still compiles, as does the NjettinessPlugin class
+the example file from v1.0.3 still compiles, as does the NjettinessPlugin class
 code that uses the default measure.
 
@@ -17,18 +17,29 @@
   * NsubjettinessRatio:  Direct access to tau_N / tau_M (the most requested
     feature)
-  * MeasureDefinition to allow access to both normalized and unnormalized measures
+  * MeasureDefinition to allow access to normalized and unnormalized measures
   * AxesDefinition to allow for access to more general axes modes
-  * Winner-Take-All recombination axes:  a faster way to find axes than beta = 1
+  * Winner-Take-All recombination axes:  a faster way to find axes than beta=1
     minimization, but with comparable performance.
   * TauComponents to get access to the pieces of the N-(sub)jettiness
     calculation.
+  * TauExtras to get complete access to get partitioning and axes information.
   * For clarity, split the example file into an example_basic_usage and
-    example_advanced_usage
+    example_advanced_usage (and example_advanced_usage_ee for e+e- collisions).
   * In Nsubjettiness, access to seedAxes() and currentAxes() to figure out the
     axes used before and after minimization.
   * In Nsubjettiness, access to currentSubjets() to get the subjet fourvectors.
+  * (v2.2)  XConePlugin, which improves on the previous NjettinessPlugin to use
+    N-jettiness as a jet finder using the new ConicalGeometric measure.
 
+-- 2.2.1:  (Sept 28, 2015)  Fix of small Makefile bug
+-- 2.2.0:  (Sept 7, 2015)  Inclusion of the XCone jet algorithm, as well as a
+           few new measures, including the "conical geometric" measure and
+           options for e+e- colliders.  Improvement of the
+           Measure/AxesDefinition interface to allow for direct
+           use in calculations.
+           * Fixed bug where MultiPass_Axes did not actually minimize
+           * Fixed floating point error with infinity^2 in various measures
 
--- 2.1.0:  (July 9, 2014) Inclusion of MeasureDefinition/AxesDefinition interface.
+-- 2.1.0:  (July 9, 2014) Inclusion of Measure/AxesDefinition interface.
            This was the first publicly available version of Nsubjettiness v2.
 -- 2.0.0:  Initial release of v2.0.  This was never officially made public.
Index: external/fastjet/contribs/Nsubjettiness/Njettiness.cc
===================================================================
--- external/fastjet/contribs/Nsubjettiness/Njettiness.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/Njettiness.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -5,5 +5,5 @@
 //  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
 //
-//  $Id: Njettiness.cc 677 2014-06-12 18:56:46Z jthaler $
+//  $Id: Njettiness.cc 821 2015-06-15 18:50:53Z jthaler $
 //----------------------------------------------------------------------
 // This file is part of FastJet contrib.
@@ -36,18 +36,77 @@
 ///////
 
+LimitedWarning Njettiness::_old_measure_warning;
+LimitedWarning Njettiness::_old_axes_warning;
+
+   
+// Constructor
 Njettiness::Njettiness(const AxesDefinition & axes_def, const MeasureDefinition & measure_def)
-: _axes_def(axes_def.create()), _measure_def(measure_def.create()) {
-   setMeasureFunctionAndAxesFinder();  // call helper function to do the hard work
-}
-
+: _axes_def(axes_def.create()), _measure_def(measure_def.create()) {}
+   
+// setAxes for Manual mode
+void Njettiness::setAxes(const std::vector<fastjet::PseudoJet> & myAxes) {
+   if (_axes_def()->needsManualAxes()) {
+      _currentAxes = myAxes;
+   } else {
+      throw Error("You can only use setAxes for manual AxesDefinitions");
+   }
+}
+   
+// Calculates and returns all TauComponents that user would want.
+// This information is stored in _current_tau_components for later access as well.
+TauComponents Njettiness::getTauComponents(unsigned n_jets, const std::vector<fastjet::PseudoJet> & inputJets) const {
+   if (inputJets.size() <= n_jets) {  //if not enough particles, return zero
+      _currentAxes = inputJets;
+      _currentAxes.resize(n_jets,fastjet::PseudoJet(0.0,0.0,0.0,0.0));
+      _current_tau_components = TauComponents();
+      _seedAxes = _currentAxes;
+      _currentPartition = TauPartition(n_jets); // empty partition
+   } else {
+      assert(_axes_def()); // this should never fail.
+      
+      if (_axes_def()->needsManualAxes()) { // if manual mode
+         // take current axes as seeds
+         _seedAxes = _currentAxes;
+         
+         // refine axes if requested
+         _currentAxes = _axes_def->get_refined_axes(n_jets,inputJets,_seedAxes, _measure_def());
+      } else { // non-manual axes
+         
+          //set starting point for minimization
+         _seedAxes = _axes_def->get_starting_axes(n_jets,inputJets,_measure_def());
+         
+         // refine axes as needed
+         _currentAxes = _axes_def->get_refined_axes(n_jets,inputJets,_seedAxes, _measure_def());
+         
+         // NOTE:  The above two function calls are combined in "AxesDefinition::get_axes"
+         // but are separated here to allow seed axes to be stored.
+      }
+      
+      // Find and store partition
+      _currentPartition = _measure_def->get_partition(inputJets,_currentAxes);
+      
+      // Find and store tau value
+      _current_tau_components = _measure_def->component_result_from_partition(_currentPartition, _currentAxes);  // sets current Tau Values
+   }
+   return _current_tau_components;
+}
+   
+
+///////
+//
+// Below is code for backward compatibility to use the old interface.
+// May be deleted in a future version
+//
+///////
+   
 Njettiness::Njettiness(AxesMode axes_mode, const MeasureDefinition & measure_def)
-: _axes_def(createAxesDef(axes_mode)), _measure_def(measure_def.create()) {
-   setMeasureFunctionAndAxesFinder();  // call helper function to do the hard work
-}
-   
+: _axes_def(createAxesDef(axes_mode)), _measure_def(measure_def.create()) {}
+
 // Convert from MeasureMode enum to MeasureDefinition
 // This returns a pointer that will be claimed by a SharedPtr
 MeasureDefinition* Njettiness::createMeasureDef(MeasureMode measure_mode, int num_para, double para1, double para2, double para3) const {
-
+   
+   _old_measure_warning.warn("Njettiness::createMeasureDef:  You are using the old MeasureMode way of specifying N-subjettiness measures.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use MeasureDefinition instead.");
+   
    // definition of maximum Rcutoff for non-cutoff measures, changed later by other measures
    double Rcutoff = std::numeric_limits<double>::max();  //large number
@@ -77,10 +136,5 @@
          break;
       case geometric_measure:
-         beta = para1;
-         if (num_para == 1) {
-            return new GeometricMeasure(beta);
-         } else {
-            throw Error("geometric_measure needs 1 parameter (beta)");
-         }
+         throw Error("This class has been removed. Please use OriginalGeometricMeasure, ModifiedGeometricMeasure, or ConicalGeometricMeasure with the new Njettiness constructor.");
          break;
       case normalized_cutoff_measure:
@@ -104,12 +158,5 @@
          break;
       case geometric_cutoff_measure:
-         beta = para1;
-         Rcutoff = para2; //Rcutoff parameter is 2nd parameter in geometric_cutoff_measure
-         if(num_para == 2) {
-           return new GeometricCutoffMeasure(beta,Rcutoff);
-         } else {
-            throw Error("geometric_cutoff_measure has 2 parameters (beta, Rcutoff)");
-         }
-         break;
+         throw Error("This class has been removed. Please use OriginalGeometricMeasure, ModifiedGeometricMeasure, or ConicalGeometricMeasure with the new Njettiness constructor.");
       default:
          assert(false);
@@ -122,4 +169,7 @@
 // This returns a pointer that will be claimed by a SharedPtr
 AxesDefinition* Njettiness::createAxesDef(Njettiness::AxesMode axes_mode) const {
+   
+   _old_axes_warning.warn("Njettiness::createAxesDef:  You are using the old AxesMode way of specifying N-subjettiness axes.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use AxesDefinition instead.");
+   
    
    switch (axes_mode) {
@@ -156,62 +206,7 @@
 }
 
-   
-// Parsing needed for constructor to set AxesFinder and MeasureFunction
-// All of the parameter handling is here, and checking that number of parameters is correct.
-void Njettiness::setMeasureFunctionAndAxesFinder() {
-   // Get the correct MeasureFunction and AxesFinders
-   _measureFunction.reset(_measure_def->createMeasureFunction());
-   _startingAxesFinder.reset(_axes_def->createStartingAxesFinder(*_measure_def));
-   _finishingAxesFinder.reset(_axes_def->createFinishingAxesFinder(*_measure_def));
-}
-
-// setAxes for Manual mode
-void Njettiness::setAxes(const std::vector<fastjet::PseudoJet> & myAxes) {
-   if (_axes_def->supportsManualAxes()) {
-      _currentAxes = myAxes;
-   } else {
-      throw Error("You can only use setAxes for manual AxesDefinitions");
-   }
-}
-   
-// Calculates and returns all TauComponents that user would want.
-// This information is stored in _current_tau_components for later access as well.
-TauComponents Njettiness::getTauComponents(unsigned n_jets, const std::vector<fastjet::PseudoJet> & inputJets) const {
-   if (inputJets.size() <= n_jets) {  //if not enough particles, return zero
-      _currentAxes = inputJets;
-      _currentAxes.resize(n_jets,fastjet::PseudoJet(0.0,0.0,0.0,0.0));
-      _current_tau_components = TauComponents();
-      _seedAxes = _currentAxes;
-      _currentJets = _currentAxes;
-      _currentBeam = PseudoJet(0.0,0.0,0.0,0.0);
-   } else {
-
-      _seedAxes = _startingAxesFinder->getAxes(n_jets,inputJets,_currentAxes); //sets starting point for minimization
-      if (_finishingAxesFinder) {
-         _currentAxes = _finishingAxesFinder->getAxes(n_jets,inputJets,_seedAxes);
-      } else {
-         _currentAxes = _seedAxes;
-      }
-      
-      // Find partition and store information
-      // (jet information in _currentJets, beam in _currentBeam)
-      _currentJets = _measureFunction->get_partition(inputJets,_currentAxes,&_currentBeam);
-      
-      // Find tau value and store information
-      _current_tau_components = _measureFunction->result_from_partition(_currentJets, _currentAxes,&_currentBeam);  // sets current Tau Values
-   }
-   return _current_tau_components;
-}
-   
-   
-// Partition a list of particles according to which N-jettiness axis they are closest to.
-// Return a vector of length _currentAxes.size() (which should be N).
-// Each vector element is a list of ints corresponding to the indices in
-// particles of the particles belonging to that jet.
-std::vector<std::list<int> > Njettiness::getPartitionList(const std::vector<fastjet::PseudoJet> & particles) const {
-   // core code is in MeasureFunction
-   return _measureFunction->get_partition_list(particles,_currentAxes);
-}
-
+
+   
+   
    
 } // namespace contrib
Index: external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.cc
===================================================================
--- external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -5,5 +5,5 @@
 //  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
 //
-//  $Id: NjettinessPlugin.cc 663 2014-06-03 21:26:41Z jthaler $
+//  $Id: NjettinessPlugin.cc 821 2015-06-15 18:50:53Z jthaler $
 //----------------------------------------------------------------------
 // This file is part of FastJet contrib.
@@ -29,5 +29,5 @@
 namespace contrib{
 
-
+LimitedWarning NjettinessPlugin::_old_constructor_warning;
 
 std::string NjettinessPlugin::description() const {return "N-jettiness jet finder";}
@@ -48,9 +48,9 @@
    
    
-   _njettinessFinder.getTau(_N, particles);
-
-   std::vector<std::list<int> > partition = _njettinessFinder.getPartitionList(particles);
-
-   std::vector<fastjet::PseudoJet> jet_indices_for_extras;
+   TauComponents tau_components = _njettinessFinder.getTauComponents(_N, particles);
+   TauPartition tau_partition = _njettinessFinder.currentPartition();
+   std::vector<std::list<int> > partition = tau_partition.jets_list();
+   
+   std::vector<int> jet_indices_for_extras;
 
    // output clusterings for each jet
@@ -73,5 +73,5 @@
       int finalJet = indices.back();
       cs.plugin_record_iB_recombination(finalJet, fakeDib);
-      jet_indices_for_extras.push_back(cs.jets()[finalJet]);  // Get the four vector for the final jets to compare later.
+      jet_indices_for_extras.push_back(cs.jets()[finalJet].cluster_hist_index());  // Get the four vector for the final jets to compare later.
    }
 
@@ -79,7 +79,14 @@
    reverse(jet_indices_for_extras.begin(),jet_indices_for_extras.end());
 
-   NjettinessExtras * extras = new NjettinessExtras(_njettinessFinder.currentTauComponents(),jet_indices_for_extras,_njettinessFinder.currentAxes());
+   // Store extra information about jets 
+   NjettinessExtras * extras = new NjettinessExtras(tau_components,jet_indices_for_extras);
+
+#if FASTJET_VERSION_NUMBER>=30100
+   cs.plugin_associate_extras(extras);
+#else
+   // auto_ptr no longer supported, apparently
    cs.plugin_associate_extras(std::auto_ptr<ClusterSequence::Extras>(extras));
-   
+#endif
+  
 }
 
Index: external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.hh
===================================================================
--- external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.hh	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -5,5 +5,5 @@
 //  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
 //
-//  $Id: NjettinessPlugin.hh 671 2014-06-10 17:47:52Z jthaler $
+//  $Id: NjettinessPlugin.hh 822 2015-06-15 23:52:57Z jthaler $
 //----------------------------------------------------------------------
 // This file is part of FastJet contrib.
@@ -26,7 +26,10 @@
 #define __FASTJET_CONTRIB_NJETTINESSPLUGIN_HH__
 
+#include <fastjet/config.h>
+
 #include "Njettiness.hh"
-#include "MeasureFunction.hh"
-#include "AxesFinder.hh"
+#include "MeasureDefinition.hh"
+#include "AxesDefinition.hh"
+#include "TauComponents.hh"
 
 #include "fastjet/ClusterSequence.hh"
@@ -41,72 +44,7 @@
 namespace contrib {
 
-//------------------------------------------------------------------------
-/// \class NjettinessExtras
-// This class contains the same information as Njettiness, but redoes it in terms of the ClusterSequence::Extras class.
-// This is done in order to help improve the interface for the main NjettinessPlugin class.
-// TODO:  This class should probably be merged with TauComponents, since both have access
-// to similar information
-class NjettinessExtras : public ClusterSequence::Extras {
-   
-   public:
-      NjettinessExtras(TauComponents tau_components, std::vector<fastjet::PseudoJet> jets, std::vector<fastjet::PseudoJet> axes) : _tau_components(tau_components), _jets(jets), _axes(axes) {}
-      
-      double totalTau() const {return _tau_components.tau();}
-      std::vector<double> subTaus() const {return _tau_components.jet_pieces();}
-      std::vector<fastjet::PseudoJet> jets() const {return _jets;}
-      std::vector<fastjet::PseudoJet> axes() const {return _axes;}
-      
-      double totalTau(const fastjet::PseudoJet& /*jet*/) const {
-         return _tau_components.tau();
-      }
-      
-      double subTau(const fastjet::PseudoJet& jet) const {
-         if (labelOf(jet) == -1) return std::numeric_limits<double>::quiet_NaN(); // nonsense
-         return _tau_components.jet_pieces()[labelOf(jet)];
-      }
-      
-      double beamTau() const {
-         return _tau_components.beam_piece();
-      }
-      
-      fastjet::PseudoJet axis(const fastjet::PseudoJet& jet) const {
-         return _axes[labelOf(jet)];
-      }
 
-      bool has_njettiness_extras(const fastjet::PseudoJet& jet) const {
-         return (labelOf(jet) >= 0);
-      }
-   
-private:
-   
-   TauComponents _tau_components;
-   std::vector<fastjet::PseudoJet> _jets;
-   std::vector<fastjet::PseudoJet> _axes;
-   
-   int labelOf(const fastjet::PseudoJet& jet) const {
-      int thisJet = -1;
-      for (unsigned int i = 0; i < _jets.size(); i++) {
-         if (_jets[i].cluster_hist_index() == jet.cluster_hist_index()) {
-            thisJet = i;
-            break;
-         }
-      }
-      return thisJet;
-   }
-};
-
-inline const NjettinessExtras * njettiness_extras(const fastjet::PseudoJet& jet) {
-   const ClusterSequence * myCS = jet.associated_cluster_sequence();   
-   if (myCS == NULL) return NULL;
-   const NjettinessExtras* extras = dynamic_cast<const NjettinessExtras*>(myCS->extras());   
-   return extras;   
-}
-
-inline const NjettinessExtras * njettiness_extras(const fastjet::ClusterSequence& myCS) {
-   const NjettinessExtras* extras = dynamic_cast<const NjettinessExtras*>(myCS.extras());   
-   return extras;   
-}
-
-/// The Njettiness jet algorithm
+/// \class NjettinessPlugin
+/// \brief Implements the N-jettiness Jet Algorithm
 /**
  * An exclusive jet finder that identifies N jets; first N axes are found, then
@@ -114,29 +52,33 @@
  * corresponding jet is simply the four-momentum sum of these particles.
  *
- * Axes can be found in several ways, specified by the AxesMode argument.  The
- * recommended choices are
+ * As of version 2.2, it is recommended to use the XConePlugin, which has
+ * sensible default values for jet finding.
  *
- * kt_axes              : exclusive kT
- * wta_kt_axes          : exclusive kT with winner-take-all-recombination
- * onepass_kt_axes      : one-pass minimization seeded by kt (pretty good)
- * onepass_wta_kt_axes  : one-pass minimization seeded by wta_kt
+ * Axes can be found in several ways, specified by the AxesDefinition argument.
+ * The recommended AxesDefinitions for jet finding (different than for jet shapes)
+ *    OnePass_AntiKT(R0)  :  one-pass minimization from anti-kT starting point
+ *    OnePass_GenET_GenKT_Axes(delta, p, R0) : one-pass min. from GenET/KT
+ *    OnePass_WTA_GenKT_Axes(p, R0)          : one-pass min from WTA/GenKT
+ * For recommendations on which axes to use, please see the README file.
+ * 
+ * Jet regions are determined by the MeasureDefinition.  The recommended choices
+ * for jet finding are
+ *    ConicalMeasure(beta,R0) : perfect cones in rapidity/azimuth plane
+ *    XConeMeasure(beta,R0)   : approximate cones based on dot product distances.
  *
- * For the UnnormalizedMeasure(beta), N-jettiness is defined as:
- *
- * tau_N = Sum_{all particles i} p_T^i min((DR_i1)^beta, (DR_i2)^beta, ...)
- *
- *   DR_ij is the distance sqrt(Delta_phi^2 + Delta_rap^2) between particle i
- *   and jet j.
+ * Other measures introduced in version 2.2 include OriginalGeometricMeasure,
+ * ModifiedGeometricMeasure, and ConicalGeometricMeasure, which define N-jettiness
+ * through dot products of particle momenta with light-like axes. OriginalGeometricMeasure
+ * produces football-shaped jets due to its central weighting of the beam measure,
+ * but ModifiedGeometric and ConicalGeometric both deform the original geometric measure
+ * to allow for cone-shaped jets. The size of these cones can be controlled through Rcutoff
+ * just as in the other measures. See the README file or MeasureDefinition.hh for information
+ * on how to call these measures.
  * 
- * The NormalizedMeausure include an extra parameter R0, and the various cutoff
- * measures include an Rcutoff, which effectively defines an angular cutoff
- * similar in effect to a cone-jet radius.
- *
  */
-
 class NjettinessPlugin : public JetDefinition::Plugin {
 public:
 
-   // Constructor with same arguments as Nsubjettiness.
+   /// Constructor with same arguments as Nsubjettiness (N, AxesDefinition, MeasureDefinition)
    NjettinessPlugin(int N,
                     const AxesDefinition & axes_def,
@@ -144,39 +86,81 @@
    : _njettinessFinder(axes_def, measure_def), _N(N) {}
    
+
+   /// Description
+   virtual std::string description () const;
+   /// Jet radius (this does not make sense yet)
+   virtual double R() const {return -1.0;} // TODO: make this not stupid
+
+   /// The actually clustering, which first called Njettiness and then creates a dummy ClusterSequence
+   virtual void run_clustering(ClusterSequence&) const;
+
+   /// For using manual axes with Njettiness Plugin
+   void setAxes(const std::vector<fastjet::PseudoJet> & myAxes) {
+      // Cross check that manual axes are being used is in Njettiness
+      _njettinessFinder.setAxes(myAxes);
+   }
+
+   /// Destructor
+   virtual ~NjettinessPlugin() {}
+
+private:
+
+   Njettiness _njettinessFinder;  ///< The core Njettiness that does the heavy lifting
+   int _N;  ///< Number of exclusive jets to find.
+
+   /// Warning if the user tries to use v1.0.3 constructor.
+   static LimitedWarning _old_constructor_warning;
    
+public:
+
    // Alternative constructors that define the measure via enums and parameters
-   // These constructors are likely be removed
+   // These constructors are deprecated and will be removed in a future version.
+   
+   /// \deprecated
+   /// Old-style constructor with 0 arguments (DEPRECATED)
    NjettinessPlugin(int N,
-                 Njettiness::AxesMode axes_mode,
-                 Njettiness::MeasureMode measure_mode)
-   : _njettinessFinder(axes_mode, measure_mode, 0), _N(N) {}
+                    Njettiness::AxesMode axes_mode,
+                    Njettiness::MeasureMode measure_mode)
+   : _njettinessFinder(axes_mode, measure_mode, 0), _N(N) {
+      _old_constructor_warning.warn("NjettinessPlugin:  You are using the old style constructor.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use the NjettinessPlugin constructor based on AxesDefinition and MeasureDefinition instead.");
+   }
    
+   /// \deprecated
+   /// Old-style constructor with 1 argument (DEPRECATED)
+      NjettinessPlugin(int N,
+                    Njettiness::AxesMode axes_mode,
+                    Njettiness::MeasureMode measure_mode,
+                    double para1)
+   : _njettinessFinder(axes_mode, measure_mode, 1, para1), _N(N) {
+      _old_constructor_warning.warn("NjettinessPlugin:  You are using the old style constructor.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use the NjettinessPlugin constructor based on AxesDefinition and MeasureDefinition instead.");
    
+   }
+   
+   /// \deprecated
+   /// Old-style constructor with 2 arguments (DEPRECATED)
    NjettinessPlugin(int N,
-                 Njettiness::AxesMode axes_mode,
-                 Njettiness::MeasureMode measure_mode,
-                 double para1)
-   : _njettinessFinder(axes_mode, measure_mode, 1, para1), _N(N) {}
+                    Njettiness::AxesMode axes_mode,
+                    Njettiness::MeasureMode measure_mode,
+                    double para1,
+                    double para2)
+   : _njettinessFinder(axes_mode, measure_mode, 2, para1, para2), _N(N) {
+      _old_constructor_warning.warn("NjettinessPlugin:  You are using the old style constructor.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use the NjettinessPlugin constructor based on AxesDefinition and MeasureDefinition instead.");
    
+   }
    
+   /// \deprecated
+   /// Old-style constructor with 3 arguments (DEPRECATED)
    NjettinessPlugin(int N,
-                 Njettiness::AxesMode axes_mode,
-                 Njettiness::MeasureMode measure_mode,
-                 double para1,
-                 double para2)
-   : _njettinessFinder(axes_mode, measure_mode, 2, para1, para2), _N(N) {}
+                    Njettiness::AxesMode axes_mode,
+                    Njettiness::MeasureMode measure_mode,
+                    double para1,
+                    double para2,
+                    double para3)
+   : _njettinessFinder(axes_mode, measure_mode, 3, para1, para2, para3), _N(N) {
+      _old_constructor_warning.warn("NjettinessPlugin:  You are using the old style constructor.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use the NjettinessPlugin constructor based on AxesDefinition and MeasureDefinition instead.");
+   }
    
-   
-   NjettinessPlugin(int N,
-                 Njettiness::AxesMode axes_mode,
-                 Njettiness::MeasureMode measure_mode,
-                 double para1,
-                 double para2,
-                 double para3)
-   : _njettinessFinder(axes_mode, measure_mode, 3, para1, para2, para3), _N(N) {}
-
-
-   // Old constructor for backwards compatibility with v1.0,
-   // where NormalizedCutoffMeasure was the only option
+   /// \deprecated
+   /// Old-style constructor for backwards compatibility with v1.0, when NormalizedCutoffMeasure was the only option
    NjettinessPlugin(int N,
                     Njettiness::AxesMode mode,
@@ -184,19 +168,8 @@
                     double R0,
                     double Rcutoff=std::numeric_limits<double>::max())
-   : _njettinessFinder(mode, NormalizedCutoffMeasure(beta, R0, Rcutoff)), _N(N) {}
+   : _njettinessFinder(mode, NormalizedCutoffMeasure(beta, R0, Rcutoff)), _N(N) {
+      _old_constructor_warning.warn("NjettinessPlugin:  You are using the old style constructor.  This is deprecated as of v2.1 and will be removed in v3.0.  Please use the NjettinessPlugin constructor based on AxesDefinition and MeasureDefinition instead.");
+   }
 
-
-
-   // The things that are required by base class.
-   virtual std::string description () const;
-   virtual double R() const {return -1.0;} // TODO: make this not stupid
-   virtual void run_clustering(ClusterSequence&) const;
-
-   virtual ~NjettinessPlugin() {}
-
-private:
-
-   Njettiness _njettinessFinder;
-   int _N;
 
 };
Index: external/fastjet/contribs/Nsubjettiness/Nsubjettiness.cc
===================================================================
--- external/fastjet/contribs/Nsubjettiness/Nsubjettiness.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/Nsubjettiness.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -5,5 +5,5 @@
 //  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
 //
-//  $Id: Nsubjettiness.cc 597 2014-04-16 23:07:55Z jthaler $
+//  $Id: Nsubjettiness.cc 821 2015-06-15 18:50:53Z jthaler $
 //----------------------------------------------------------------------
 // This file is part of FastJet contrib.
@@ -29,4 +29,7 @@
 namespace contrib {
 
+LimitedWarning Nsubjettiness::_old_constructor_warning;
+   
+   
 //result returns tau_N with normalization dependent on what is specified in constructor
 double Nsubjettiness::result(const PseudoJet& jet) const {
